{{/* 

    Samenstellen van XML Schena iStandaard Estafette Model Element op basis van:
    - Standaard-naam Configuratie Parameter
    - Bericht Klasse Element UML-XMI Data
    - Bericht Klasse Element Parameters

    Context: dict
                "standaard"
                "berichtCode"
                "elementData"
                "elementParams"
                "identNr"

    Returns: iStandaard Estafette Model XML Schena Element
  
*/}}

{{ $standaard := .standaard }}
{{ $berichtCode := .berichtCode }}
{{ $elementData := .elementData }}
{{ $elementParams := .elementParams }}
{{ $identNr := .identNr }}
{{ $ident := partial "utils/build-ident" $identNr }}
{{ $baseType := print $standaard ":" $elementData.dataType }}

{{ $kardinaliteit := "" }}
{{ if not $elementData.verplicht }}
    {{ $kardinaliteit = ` minOccurs="0"` }}
{{ end }}

{{ $xsElementBegin := print $ident.spaces `<xs:element name="` $elementData.naam `"` }}
{{ $annotation := partial "xsd/xs-annotation-documentation" (dict
    "documentation" $elementData.beschrijving
    "identNr" $identNr
) }}
{{ $xsElement := print $xsElementBegin ` type="` $baseType `"` $kardinaliteit ">" $annotation }}
{{ $isBerichtCodeType := eq $elementData.dataType "LDT_BerichtCode" }}

{{ if or (isset $elementParams "regels") $isBerichtCodeType }}

    {{ if or (isset $elementParams.regels "constraints") $isBerichtCodeType }}
        {{ $typeIdent := partial "utils/build-ident" (add $identNr 1) }}
        {{ $xsElement = print $xsElementBegin $kardinaliteit ">" $annotation "\n" $typeIdent.spaces "<xs:simpleType>\n"}}
        {{ $xsElement = print $xsElement $typeIdent.spaces $typeIdent.tab `<xs:restriction base="` $baseType `">` "\n" }}
        {{ $constraintsParams := partial "istd/istd-regels-params" (dict
            "regelType" "Constraints"
            "regelCodes" $elementParams.regels.constraints
        ) }}

        {{ if $isBerichtCodeType }}
            {{ $xsdString := print "pattern value=" $berichtCode }}
            {{ $constraintsParams = $constraintsParams | append (dict "xsdString" $xsdString) }}
        {{ end }}

        {{ range $constraintParams := $constraintsParams }}
            {{ $xsElement = print $xsElement $typeIdent.spaces $ident.tab $ident.tab "<xs:" $constraintParams.xsdString "/>\n" }}
        {{ end }}

        {{ $xsElement = print $xsElement $typeIdent.spaces $ident.tab "</xs:restriction>\n" }}
        {{ $xsElement = print $xsElement $typeIdent.spaces "<xs:simpleType>"}}
    {{ end }}

{{ end }}

{{ $xsElement = print $xsElement "\n" $ident.spaces "</xs:element>" }}

{{ return $xsElement }}